package com.earthwormlab.mika.utils;

import android.content.Context;
import android.util.Xml;

import org.xmlpull.v1.XmlPullParser;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class LoadDistricts {
	
	public static final HashMap<String, List<HashMap<String, String>>> districts = new HashMap<String, List<HashMap<String, String>>>();
	
    public static void parse(InputStream is) throws Exception {
    	districts.clear();
        XmlPullParser xpp = Xml.newPullParser();
        xpp.setInput(is,"UTF-8");
        int eventType = xpp.getEventType();
        HashMap<String, String> attr = null;
        while (eventType != XmlPullParser.END_DOCUMENT){
             switch (eventType) {  
                     case XmlPullParser.START_DOCUMENT:
                         break;  
                     case XmlPullParser.START_TAG:
                    	 attr = new HashMap<String, String>();
                         if (xpp.getName().equals("District")) {
                        	 String nameSpace = xpp.getNamespace();
                        	 String pid = xpp.getAttributeValue(nameSpace, "parent_id");
                        	 attr.put("CID", pid);
                        	 String id = xpp.getAttributeValue(nameSpace, "id");
                        	 attr.put("ID", id);
                        	 String DistrictName = xpp.getAttributeValue(nameSpace, "name");
                        	 attr.put("DistrictName", DistrictName);
                        	 
                        	 if(districts.containsKey(pid)){
                        		 List<HashMap<String, String>> list = districts.get(pid);
                        		 list.add(attr);
                        	 }else{
                        		 List<HashMap<String, String>> list = new ArrayList<HashMap<String,String>>();
                        		 list.add(attr);
                        		 districts.put(pid, list);
                        	 }
                         } 
                         break;  
            
                     case XmlPullParser.END_TAG:
                         break;  
                     }  
                     eventType = xpp.next();
        	}
  
        }
    
    public static List<HashMap<String, String>> getDistricts(Context context, String key){
    	synchronized (districts){
    		if(districts.isEmpty()){
    			try {
    				parse(context.getAssets().open("District.xml"));
    			} catch (IOException e) {
    				// TODO Auto-generated catch block
    				e.printStackTrace();
    			} catch (Exception e) {
    				// TODO Auto-generated catch block
    				e.printStackTrace();
    			}
    		}
    	}
    	return districts.get(key);
    }
}
